`timescale 1ns / 1ns
/* to do Hnadschke switch to LCD read-mode , and poll MSB bit 7 set to one $80 */
  // Active HDL Tutorial - Part 2 
 // Kyle Gilsdorf

module lcd(
				input wire clk,
				output reg lcd_e,
				output reg lcd_rw,
				output reg lcd_rs,
				output reg [7:0] lcd_data
			  );
			  /*
			`define MS15 		 'd750000
			`define DATA_HOLD  'd420000
			`define E_HOLD		 'd420000
			`define E_SETTLE	 'd210000
			*/
			`define MS15 		 'd2
			`define DATA_HOLD    'd2
			`define E_HOLD		 'd2
			`define E_SETTLE	 'd2
			
			localparam  s0 = 5'd0,
							s1 = 5'd1,
							s2 = 5'd2,
							s3 = 5'd3,
							s4 = 5'd4,
							s5 = 5'd5,
							s6 = 5'd6,
							s7 = 5'd7,
							s8 = 5'd8;
							
			localparam DATA = 1'b1;
			localparam CMD  = 1'b0;
				
			reg [7:0] state;
			reg [7:0] next_state=0;
			reg [7:0] pop_state=0;
			reg [20:0] count;
			reg [20:0] T_count=0;
			
			reg [20:0] W_count=0;
			reg [3:0] W_state=0;
			reg [3:0] W_next_state=0;
			
			reg [20:0] E_count=0;
			reg [3:0] E_state=0;
			reg [3:0] E_next_state=0;
			
			reg start_E;
			reg E_done;
			reg start_W;
			reg W_done;
			reg rs_select;	// CMD =0 
			
			reg [7:0] T_lcd_data;  
        //reg [87:0] strdata = "*+l*o wor*+";
		  reg [87:0] strdata = "*12345678*+";
//	     reg [87:0] strdata = "hello world";	
			integer i;
				  
			always @(posedge clk)
				begin
						T_count = T_count + 1;
						count = T_count;
						state = next_state;
					case (state)
						s0: begin
								if (count == `MS15)
									begin
										next_state = s1;
										pop_state = s2;
										start_W = 1'b1;
										rs_select = CMD;
									//	T_lcd_data = 8'b00111100; 
									  T_lcd_data =  8'd1; // strdata[79:8];
										//Function set DL = 8bit, NL = 2, Font = 5x11
									end
							 end
						s1: begin
								W_machine(clk, start_W, T_lcd_data, rs_select, W_done);
								if (W_done == 1'b1)
									begin
										next_state = pop_state;
									end
							 end
						s2: begin
								next_state = s1;
								pop_state = s3;
								start_W = 1'b1;
								//T_lcd_data = 8'b00111100;//Function set DL = 8bit, NL = 2, Font = 5x11 
								T_lcd_data =  8'd3;
							 end
						s3: begin
								next_state = s1;
								pop_state = s4;
								start_W = 1'b1;
								//T_lcd_data = 8'b00001111; // display on/off control
								T_lcd_data =  8'd4;
							 end
						s4: begin					 
								next_state = s1;
								pop_state = s5;
								start_W = 1'b1;
								T_lcd_data = 8'b00000001; // display clear
							 end
						s5: begin
								next_state = s1;
								pop_state = s6;
								start_W = 1'b1;
								T_lcd_data = 8'b00000110; //entry mode set
							 end
						s6: begin
								next_state = s1;
								pop_state = s7;
								start_W = 1'b1;
								rs_select = DATA;
								i = 87;	   // 88 
								T_lcd_data = strdata[i-:8];
							 end
						s7: begin
								i = i - 8;
								T_lcd_data = strdata[i-:8];
								if ( i > 0 )
									next_state = s1;
								else
									next_state = s8;
							 end
						s8: begin
								next_state = s8;
							 end
						default:
							 next_state = s0;
					endcase
				end
				
task W_machine;
	input clk;
	input start_W;
	input [7:0] W_data;
	input RS_select;
	output W_done;
	
	begin
		W_count = W_count + 1;
		W_state = W_next_state;
		case (W_state)
				0:	begin
						if (start_W == 1'b1)
						begin
							W_next_state = 1;
							W_count = 0;
							W_done = 1'b0;
							lcd_data = W_data;
							lcd_rw = 1'b0;
							lcd_rs = RS_select;
						end
					end
				1: begin
						if (W_count == `E_SETTLE)
						begin
							W_count = 0;
							W_next_state = 2; // goto E
							start_E = 1'b1;	  // set
						end
					end
				2:	begin			   /* ??*/
						E_machine(clk, start_E, E_done);
						if (E_done == 1'b1)
						begin
							W_done = 1'b1;
							W_next_state = 0;  
							 	start_E = 1'b0;	  // clear
						end			
					end
				default:
					W_next_state = 0;
		endcase
	end
	
endtask
	
	
task E_machine;
	input clk;
	input start_E;
	output E_done;

		begin
			E_count = E_count + 1;
			E_state = E_next_state;
			case (E_state)
				0:	begin
						if (start_E == 1'b1)	 // ?is it 
						begin
							E_next_state = 1;
							E_count = 0;
							E_done = 1'b0;	 
							///
							///   start_E = 1'b0;	 
							lcd_e = 1'b1;
						end
					end
				1:	begin
						if (E_count == `E_HOLD)
						begin
							E_count = 0;
							E_next_state = 2;
							lcd_e= 1'b0;
						end				
					end
				2:	begin
						if (E_count == `E_SETTLE)
						begin
							E_count = 0;
							E_next_state = 0;
							E_done = 1'b1;
						  
						end
					end
				default:
					E_next_state = 0;
			endcase
		end
endtask

endmodule
